/**
This class models a frame.
*/
public class Frame
{
   /**
   Constructs a frame.
   @param seqNum the sequence number
   @param ackNum the acknowledgement number
   @param info the packet data
   */
   public Frame(int seqNum, int ackNum, char info)
   {
      seq = seqNum;
      ack = ackNum;
      this.info = info;
   }
   
   /**
   Returns the sequence number.
   @return the sequence number
   */
   public int getSeq()
   {
      return seq;
   }
   
   /**
   Returns the acknowledgement number.
   @return the acknowledgement number
   */
   public int getAck()
   {
      return ack;
   }
   
   /**
   Returns the packet data.
   @return the packet data
   */
   public char getInfo()
   {
      return info;
   }
   
   /**
   Causes an error in this frame.
   */
   public void invalidate()
   {
      seq = -1;
      ack = -1;
   }
   
   /**
   Returns this frame as a string.
   @return the string representation
   */
   public String toString()
   {
      return "{" + seq + ", " + ack + ", " + info + "}";
   }
   
   private int seq;
   private int ack;
   private char info;
}
