import java.io.*;
import javax.swing.Timer;
import java.awt.event.*;

/**
Sliding window protocol for HW2.  This class is the driver.
*/
public class SlidingSimulator
{
   private static String readLine(BufferedReader source) throws IOException
   {
      String line;
      do
      {
         line = source.readLine();
         if (line == null)
            throw new EOFException();
      }
      while (line.length() == 0 || line.startsWith("//"));
      return line;
   }
   
   private static void setup(BufferedReader source) throws IOException
   {
      totalTime = Integer.parseInt(readLine(source));
      machine1 = new DataLinkLayer(
         readLine(source),
         readLine(source),
         Double.parseDouble(readLine(source)),
         Integer.parseInt(readLine(source)),
         Integer.parseInt(readLine(source)));
      machine2 = new DataLinkLayer(
         readLine(source),
         readLine(source),
         Double.parseDouble(readLine(source)),
         Integer.parseInt(readLine(source)),
         Integer.parseInt(readLine(source)));
      physicalLayer = new PhysicalLayer(machine1, machine2);
   }
   
   public static void main(String[] args)
   {
      if (args.length == 0)
      {
         System.out.println("No input file");
         System.exit(1);
      }
      
      try
      {
         BufferedReader source = new BufferedReader(new FileReader(args[0]));
         setup(source);
         source.close();
      }
      catch (FileNotFoundException e)
      {
         System.out.println("File not found");
         System.exit(2);
      }
      catch (IOException e)
      {
         System.out.println("Bad input file");
         System.exit(3);
      }
      catch (NumberFormatException e)
      {
         System.out.println("Invalid input data");
         System.exit(4);
      }
      
      new Timer(totalTime, 
         new ActionListener()
         {
            public void actionPerformed(ActionEvent evt)
            {
               System.exit(0);
            }
         }).start();
      machine1.protocol4();
      machine2.protocol4();
      try
      {
         Thread.sleep(totalTime * 2);
      }
      catch (InterruptedException e)
      {
      }
   }
   
   private static DataLinkLayer machine1;
   private static DataLinkLayer machine2;
   private static PhysicalLayer physicalLayer;
   private static int totalTime;
}
